"use server";

import { AuthConfig } from "@/auth";
import { requestGetFetch } from "@/utils/fetch";
import { Session } from "next-auth";
import { getServerSession } from "next-auth";

export async function getRequestList() {
  try {
    const session: Session = await getServerSession(AuthConfig);
    const token = session?.token;
    const path = "users/inactive/club owner";
    const response = await requestGetFetch({
      path,
      options: {
        headers: {
          // credentials: "same-origin",
          // "X-Requested-With": "XMLHttpRequest",
          Authorization: `Bearer ${token}`,
          "Content-Type": "application/json",
          Accept: "application/json",
        },
        cache: 'no-store',
      },
    });
    return response;
  } catch (error) {
    if (error) {
      // switch (error.type) {
      //   case "CredentialsSignin":
      //     return "Invalid credentials.";
      //   default:
      //     return "Something went wrong.";
      // }
    }
    throw error;
  }
}



export async function getClubRequestList() {
  try {
    const session: Session = await getServerSession(AuthConfig);
    const token = session?.token;
    const path = "club-owner/list";
    const response = await requestGetFetch({
      path,
      options: {
        headers: {
          // credentials: "same-origin",
          // "X-Requested-With": "XMLHttpRequest",
          Authorization: `Bearer ${token}`,
          "Content-Type": "application/json",
          Accept: "application/json",
        },
        cache: 'no-store',
      },
    });
    return response;
  } catch (error) {
    if (error) {
      // switch (error.type) {
      //   case "CredentialsSignin":
      //     return "Invalid credentials.";
      //   default:
      //     return "Something went wrong.";
      // }
    }
    throw error;
  }
}

export async function updateClubRequest(data: { id: string | number; status: string }) {
  try {
    const session: Session = await getServerSession(AuthConfig);
    const token = session?.token;
    const path = "club/request-resolve";
    const response = await requestGetFetch({
      path,
      options: {
        method: "Post",
        headers: {
          // credentials: "same-origin",
          // "X-Requested-With": "XMLHttpRequest",
          Authorization: `Bearer ${token}`,
          "Content-Type": "application/json",
          Accept: "application/json",
        },
        cache: 'no-store',
        body: JSON.stringify(data || {}),
      },
    });
    return response;
  } catch (error) {
    if (error) {
      // switch (error.type) {
      //   case "CredentialsSignin":
      //     return "Invalid credentials.";
      //   default:
      //     return "Something went wrong.";
      // }
    }
    throw error;
  }
}


export async function updateRequest(data: { userId: string | number; status: string }) {
  try {
    const session: Session = await getServerSession(AuthConfig);
    const token = session?.token;
    const path = "users/update-status";
    const response = await requestGetFetch({
      path,
      options: {
        method: "Post",
        headers: {
          // credentials: "same-origin",
          // "X-Requested-With": "XMLHttpRequest",
          Authorization: `Bearer ${token}`,
          "Content-Type": "application/json",
          Accept: "application/json",
        },
        cache: 'no-store',
        body: JSON.stringify(data || {}),
      },
    });
    return response;
  } catch (error) {
    if (error) {
      // switch (error.type) {
      //   case "CredentialsSignin":
      //     return "Invalid credentials.";
      //   default:
      //     return "Something went wrong.";
      // }
    }
    throw error;
  }
}
